#!/bin/sh

# binaries
#breakid="/home/cagriuluc/sat/breakid/src/BreakID"
#kissat="/home/cagriuluc/sat/kissat_fork/build/kissat"
#breakid="./breakid/src/BreakID"
#kissat="./kissat/build/kissat"
breakid="./BreakID"
kissat="./kissat"
#veripb="/home/cagriuluc/sat/.local/bin/veripb --stats"
veripb="veripb" 
f=$1
dirp=$2
# PRE
mkdir -p bidlog
mkdir -p solverlog
fbasename="$(basename -- $f)"


# STEP 1: BREAKID
breakidlog="$dirp/proof.out"

command="$breakid -f $f  -v 0 -t 150 -s 50 -no-bin -no-relaxed -logfile  $breakidlog"
resfile="./bidlog/$fbasename.breakid.result"





# STEP 2: KISSAT
solverlog="./solverlog/$fbasename.solverbroken.pbp"
#cat "" > $solverlog
command2="$kissat --no-binary  $breakidlog"
#command2="$kissat --no-binary -"
#TODO TO CHECK: CAN WE EDIT KISSAT SO THAT
# 1. We can pipe from breakid to kissat (less overhead in IO)
# 2. Kissat writes its log to the same file as breakid (and so kissat does not write the first couple of lines)
# 3. No file manipulation is needed on the logs (as below)
# 4. Kissat and breakid have no race conditions wrt file writing.


echo "NOW RUNNING:"
echo "$command > $command2"
$command | $command2

# STEP 3: PREPARE COMBINED LOG

#echo "load_order" >> $breakidlog;  tail -n +3 $solverlog >> $breakidlog;

# STEP 4 (verification only): run VeriPB
#command="$veripb --arbitraryPrecision --cnf $f $breakidlog" 
#resfile="$f.veripbBroken.result"
#outputfile="$resfile.out"

#echo "NOW RUNNING:"
#echo "$command"
#$command #2> $outputfile 1> $resfile
