#!/bin/sh

cp $1 input.cnf


INVAR=$(grep "p cnf" input.cnf | awk '{print $3}')
INCLS=$(grep "p cnf" input.cnf | awk '{print $4}')

if [ $INVAR -gt 500000 ] || [ $INCLS -gt 1000000 ]
then # more than 500k variables or 1mil clauses, skip PReLearn

  echo "Start Kissat"

  ./../kissat/build/kissat input.cnf --relaxed solve.drat --no-binary > kissat.out

  echo "End Kissat"

  p=$(grep "s SATISFIABLE" kissat.out | wc | awk '{print  $1}')

  if [ $p -gt 0 ]
  then
    # SAT case
    
    # let starExec do the checking
    cat kissat.out
    
  else
  # UNSAT case
    cat kissat.out
    echo "Start UNSAT"
    
    mv solve.drat $2/proof.out
    
    # place proofs into correct starExec file
  #  mv full_proof.dpr $2/proof.out

    # lcoal checking for test run

  #  echo "Start Trim"
  #
  #  ./../dpr-trim/dpr-trim $1 full_proof.dpr -L proof.lpr
  #
  #  echo "End Trim"
  #
  #  echo "Start Cake"
  #
  #
  #
  #  ./../cake_lpr/cake_lpr $1 proof.lpr
  #
  #  echo "End Cake"
  #
    
    echo "End UNSAT"
  fi

else


  timeout 100s ./../sadical/sadical input.cnf --pre_iterations=50 --verbose=0

  #mv pr_clauses_full.dpr $2"/pr_clauses_full.dpr"
  #mv pr_clauses.cnf $2"/pr_clauses.cnf"
  #mv pr_units.dpr $2"/pr_units.dpr"
  #mv pr_units.cnf $2"/pr_units.cnf"

  cat input.cnf pr_clauses.cnf > temp.cnf

  echo "Start Kissat"

  ./../kissat/build/kissat temp.cnf --relaxed solve.drat --no-binary > kissat.out

  echo "End Kissat"

  p=$(grep "s SATISFIABLE" kissat.out | wc | awk '{print  $1}')

  if [ $p -gt 0 ]
  then
    # SAT case
    
    # let starExec do the checking
    cat kissat.out
    
  else
  # UNSAT case
    cat kissat.out
    echo "Start UNSAT"
    
    cat pr_clauses_full.dpr solve.drat > $2/proof.out
    
    # place proofs into correct starExec file
  #  mv full_proof.dpr $2/proof.out

    # lcoal checking for test run

  #  echo "Start Trim"
  #
  #  ./../dpr-trim/dpr-trim $1 full_proof.dpr -L proof.lpr
  #
  #  echo "End Trim"
  #
  #  echo "Start Cake"
  #
  #
  #
  #  ./../cake_lpr/cake_lpr $1 proof.lpr
  #
  #  echo "End Cake"
  #
    
    echo "End UNSAT"
  fi

fi
