## Version 1.0.0

- Checking file info signature of compressed files first
  before committing to uncompress them (StarExec work around).

- Move scripts to `scripts` sub-directory and added `release`
  and `competition` script.

- Added a `configure --competition` configuration.

- Support for current resident set size on Apple (Mach/OSX).

- Trying to keep code compilable with C++11 (for Apple).

- Checking for compiler to support C++11 by default (for Apple).

- Replaced 'sprintf' by 'snprintf' (to support newest 'clang' on Apple).

## Version 0.9.0

- Reduced changes that messages are garbled.

- Autocompletion script for bash in `src/shared/completion.sh`.

- Local search break score table smoothed towards an epsilon (1e-10).

- New option to use fitted CB value alternating with default 2.0 in local
  (which is however disabled at run-time by default).

- Variable elimination focus on irrelevant variables using the heap based
  priority queue for variable elimination with a new difference based
  elimination score as tie-breaker, computed as difference of the product
  and sum of occurrences.

- On-the-fly garbage collection of garbage references.

- Compile-time option '--no-options' to fix options at compile-time.

- Compile-time option '--no-compact' enables 64-bit references.

- Compile-time option '--quiet' to remove messages and profiling.

## Version 0.8.4

- Fixed '-E' and '-R' option usage.

- Optimized buffered DIMACS file reading and proof trace writing.

## Version 0.8.3

- Fixed various issues with `move_redundant_clauses` code.

- Moved propagation code into header `propagate.hpp` and forced
  instantiation through compile-time macros for all three propagators.

- Factored out (shared) `dependencies.hpp` from `variant.hpp` to make
  compile-time option dependencies more explicit (and global).

- Turned both `NREPLACEMENTCACHE` and `IMPROVEREASONS` (no typo: it is
  disabled by default) completely into compile-time-options.

- Renamed `NSEARCHED` to `NREPLACEMENTCACHE`.

## Version 0.8.2

- Added `transitive` and `substitute` to vanilla solver
  (which gives the `straciatella` variant on-top of `vanilla` already).

- Disabled `searched` replacement cache option for `vanilla`.

## Version 0.8.1

- Merged development branch back to master.

- Added [`src/vanilla`](src/vanilla) variant mimicking MiniSAT.

- Added [`src/default`](src/default) variant with most features and slightly
  costly disabled options disabled at compile-time.

- Added [`src/generic`](src/generic) variant with all features enabled.

- Actual source code of solver variants moved to [`src`](src).

- Common non-solver specific code resides in [`src/shared`](src/shared).
