#ifndef _tabularasat_configurations_hpp_INCLUDED
#define _tabularasat_configurations_hpp_INCLUDED

#ifndef NOPTIONS

#include "options.hpp"
#include "shared.hpp"

#include <vector>

namespace TabularaSAT {

struct SolverConfigurations : Configurations {

  SolverOptions &options;
  bool initialized = false;
  std::vector<Configuration *> list;

  SolverConfigurations (SolverOptions &);
  void initialize ();

  ~SolverConfigurations ();

  Configuration **begin () {
    if (!initialized)
      initialize ();
    return &list[0];
  }

  Configuration **end () {
    if (!initialized)
      initialize ();
    return &list[list.size ()];
  }
};

}; // namespace TabularaSAT

#endif

#endif
