#ifndef _tabularasat_connect_hpp_INCLUDED
#define _tabularasat_connect_hpp_INCLUDED

#include "references.hpp"
#include "solver.hpp"

namespace TabularaSAT {

inline void Solver::connect_binary (unsigned lit, unsigned blocking) {
  debug_binary (lit, blocking, "connecting %s to %s in",
                debug_literal (lit), debug_literal (blocking));
  push_reference (lit, tag_binary (blocking), false);
}

inline void Solver::connect_clause (unsigned lit, Reference ref) {
  assert (!watching);
  debug_reference (ref, "connecting %s in", debug_literal (lit));
  push_reference (lit, ref, false);
}

}; // namespace TabularaSAT

#endif
