# Shared Non-Solver Specific Code

Here is code shared between the solver variants which is supposed to be
completely independent of the compiled variant and in principle could be
even compiled just once, even though at the moment we compile it for each
solver separately in order to allow separate compile-time configurations
such as compiling with and without debugging or symbols.

The actual solver source code sits in `generic` which is instantiated
through defines in the individual `variant.hpp` files.  The shared code here
does not use those definitions in contrast to `generic/solver.hpp`.

The `makefile.in` template is used in the build process by all variants.
