#ifndef _tabularasat_clause_hpp_INCLUDED
#define _tabularasat_clause_hpp_INCLUDED

#include "solver.hpp"

namespace TabularaSAT {

inline void Solver::update_position (Clause *c) {
  size_t pos = clauses.position (c);
  if (c->redundant) {
    if (pos < first_redundant) {
      first_redundant = pos;
      debug ("new first redundant position %zu", pos);
    }
#ifndef NGLUE
    if (pos < first_tier2 && c->glue > OPTION (tier1_max_glue)) {
      first_tier2 = pos;
      debug ("new first redundant tier2 position %zu", pos);
    }
#endif
  } else {
    if (pos > last_irredundant) {
      last_irredundant = pos;
      debug ("new last irredundant position %zu", pos);
    }
  }
}

inline bool Solver::satisfied_clause (Clause *c) {
  if (level) {
    for (auto lit : *c)
      if (fixed (lit) > 0)
        return true;
  } else {
    for (auto lit : *c)
      if (values[lit] > 0)
        return true;
  }
  return false;
}

}; // namespace TabularaSAT

#endif
