#ifndef _dependencies_hpp_INCLUDED
#define _dependencies_hpp_INCLUDED

// Here we put compile-time dependencies of options/features, which are
// are either forced by the code (e.g., vivification misuses the 'replaced'
// field in clauses and thus requires 'NREPLACEMENTCACHE' to be defined), or
// make sure to disable redundant code for other options (e.g., 'NDELAY').

#if defined(NREPLACEMENTCACHE) && !defined(NVIVIFY)
#define NVIVIFY // As vivification misuses the 'replaced' field in clauses.
#endif

#if defined(NVIVIFY)
#define NDELAY // Currently only used for 'NVIVIFY'.
#endif

#if defined(NTARGET) && defined(NREPHASE)
#define NUPDATEPHASES // Target and best phases updated in 'update_phases'.
#endif

#if defined(NREPHASE)
#define NWALK // Local search only called from 'rephase_walk'.
#endif

#endif
