#ifndef _tabularasat_watch_hpp_INCLUDED
#define _tabularasat_watch_hpp_INCLUDED

#include "references.hpp"
#include "solver.hpp"

namespace TabularaSAT {

inline void Solver::watch_binary (unsigned lit, unsigned blocking) {
  debug_binary (lit, blocking, "watching %s with blocking %s in",
                debug_literal (lit), debug_literal (blocking));
  push_reference (lit, tag_binary (blocking), false);
}

inline void Solver::watch_literal (unsigned lit, unsigned blocking,
                                   Reference ref) {
  assert (watching);
  debug_reference (ref, "watching %s with blocking literal %s in",
                   debug_literal (lit), debug_literal (blocking));
  References *watches = references (lit);
  push_reference (lit, watches, tag_large (blocking), true);
  assert (watches->_size < watches->_capacity);
  watches->data[watches->_size++] = ref;
}

inline void Solver::watch_clause (Clause *c) {
  Reference ref = reference_clause (c);
  watch_literal (c->literals[0], c->literals[1], ref);
  watch_literal (c->literals[1], c->literals[0], ref);
}

}; // namespace TabularaSAT

#endif
