## TabularaSAT Vanilla

This is the `vanilla` variant of TabularaSAT with similar heuristics used
in MiniSAT last changed in 2015 which was used in the SAT Competition as
MiniSAT 2.2.0 for a long time in the MiniSAT hack track and actually did not
change much since 2009.  The considered version of MiniSAT still has a crude
mechanism for reducing less relevant learned clauses and does not
incorporate other advances made by Glucose around 2011, i.e., neither has
glucose levels to predict clause usefulness (also called 'glue' or 'LBD')
nor does it have improved restarts as pioneered by the Glucose team.

Our TabularaSAT `vanilla` variant is more memory efficient than MiniSAT
though due to using virtual binary clauses and has faster algorithms for
reducing irrelevant redundant (learned) clauses.  Both solvers have bounded
variable elimination and subsumption.  The later is implemented slightly
faster through forward subsumption checking.  There is also a run-time
option '--inprocessing' to turn on inprocessing for subsumption and
elimination, but does not have any other of the preprocessors of the default
variant.

Use `./configure && make` for optimizing build process and `./configure
--debug && make` if you want to include symbols and disable assertion
checking.  If you compiled with debugging support then you can also log
internal execution by using `--logging` as command line option to `solver`.
The resulting binary is produced as `../../build/vanilla/binary` and then
copied to `../../bin/tabularasat-vanilla` and linked to `./solver`.

There are also some regression tests included and `make test` executes them
and should not produce any failures.

Note, in principle this version should behave the same as the generic
variant with configuration option `--vanilla` except that the `generic`
variant disables modern features at run-time while the `vanilla` variant
does not even include their code (remove by the compiler preprocessor).
